<!--
  TO-DO LIST:

  1. On load, get game info where `game_details` === $route.gameId
  2. Get more game info where `games` === `game_details.game_id`
  3. Get players of team where `game_details.teams[0 && 1]` === `team_user.team_id`
  4. Add win/lose functionality
    1. If `game_details.teams[0]` wins, get all players of team.
    2. Each player will have a data at `win_lose` tree with the following structure:
      { game_detail: game_details.key, status: 'win', uid: player_uid }
-->
<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12 class="text-sm-center" v-if="loading">
          <v-progress-circular indeterminate class="primary--text"></v-progress-circular>
        </v-flex>
        <v-flex sm12 v-else>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">{{gameType}}</div>
                <div class="grey--text">{{$timestamp(game.time, 'LLL')}}</div>
              </div>
            </v-card-title>
            <v-form method="post" @submit.prevent="saveChanges" ref="gameForm">
              <v-card-text>
                <v-layout row>
                  <v-flex sm7 class="pr-2">
                    <!-- Game Info -->
                    <h3 class="grey--text subheading fw-300 mb-0">Game Information</h3>
                    <v-select label="Type" v-model="game['type']" :items="$store.state.gameTypes" :rules="[$rules.required]" required></v-select>
                    <v-text-field label="Place" v-model="game['place']" :rules="[$rules.required]" required />
                    <v-divider class="mt-3"></v-divider>
                    <h3 class="grey--text subheading fw-300 mb-0">Game Schedule</h3>
                    <v-menu lazy v-model="picker['date']" :close-on-content-click="false" max-width="290" :nudge-left="45" class="mr-2">
                      <v-text-field slot="activator" label="Date" v-model="date" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-date-picker v-model="date" scrollable actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-date-picker>
                    </v-menu>
                    <v-menu lazy v-model="picker['time']" :close-on-content-click="false" max-width="290" :nudge-left="45">
                      <v-text-field slot="activator" label="Time" v-model="time" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-time-picker v-model="time" actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-time-picker>
                    </v-menu>
                    <v-text-field label="Duration" v-model="game['duration']" />
                  </v-flex>
                  <!-- Other Information -->
                  <v-flex sm5 class="pl-2">
                    <h3 class="grey--text subheading fw-300 mb-0">Game Starting Schedule</h3>
                    <v-menu lazy v-model="picker['startDate']" :close-on-content-click="false" max-width="290" class="mr-2">
                      <v-text-field slot="activator" label="Date" v-model="startDate" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-date-picker v-model="startDate" scrollable actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-date-picker>
                    </v-menu>
                    <v-menu lazy v-model="picker['startTime']" :close-on-content-click="false" max-width="290">
                      <v-text-field slot="activator" label="Time" v-model="startTime" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-time-picker v-model="startTime" actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-time-picker>
                    </v-menu>
                    <v-divider></v-divider>
                    <h3 class="grey--text subheading fw-300 mb-0">Game Ending Schedule</h3>
                    <v-menu lazy v-model="picker['endDate']" :close-on-content-click="false" max-width="290" class="mr-2">
                      <v-text-field slot="activator" label="Date" v-model="endDate" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-date-picker v-model="endDate" scrollable actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-date-picker>
                    </v-menu>
                    <v-menu lazy v-model="picker['endTime']" :close-on-content-click="false" max-width="290">
                      <v-text-field slot="activator" label="Time" v-model="endTime" readonly :rules="[$rules.required]" required></v-text-field>
                      <v-time-picker v-model="endTime" actions>
                        <template scope="{save, cancel}">
                          <v-card-actions>
                            <v-btn flat primary @click="cancel()">Cancel</v-btn>
                            <v-btn flat primary @click="save()">Done</v-btn>
                          </v-card-actions>
                        </template>
                      </v-time-picker>
                    </v-menu>
                    <v-divider></v-divider>
                    <h3 class="grey--text subheading fw-300 mb-0">Status</h3>
                    <v-select label="Type" v-model="game['status']" :items="$store.state.gameStatus" :rules="[$rules.required]" required></v-select>
                  </v-flex>
                </v-layout>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-btn flat primary type="submit" :loading="saving" :disabled="saving">
                  Save Changes
                  <span slot="loader">Saving...</span>
                </v-btn>
                <v-dialog v-model="dialog.changesSaved" lazy>
                  <v-card>
                    <v-card-title class="pb-0">
                      <div class="headline">Done</div>
                    </v-card-title>
                    <v-card-text>
                      Changes to this game has been saved.
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer />
                      <v-btn class="primary--text" flat @click="dialog.changesSaved = false">Okay</v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-card-actions>
            </v-form>              
          </v-card>
        </v-flex>
      </v-layout>
      <!-- <v-layout row class="mt-4">
        <v-flex sm12>
          <add-player :game-id="$route.params.id" v-show="!loading"></add-player>
        </v-flex>
      </v-layout> -->
    </v-container>
  </main>
</template>

<script>
  import moment from 'moment'
  import AddPlayer from '@/components/add-player'
  export default {
    name: 'game',
    components: {AddPlayer},
    watch: {
      startDate (to, from) {
        let format = this.startTime ? moment(to + ' ' + this.startTime, 'YYYY-MM-DD h:mma') : moment(to, 'YYYY-MM-DD')
        this.game.startTime = format.unix()
      },
      startTime (to, from) {
        let format = this.startDate ? moment(to + ' ' + this.startDate, 'h:mma YYYY-MM-DD') : moment(to, 'h:mma')
        this.game.startTime = format.unix()
      },
      endDate (to, from) {
        let format = this.endTime ? moment(to + ' ' + this.endTime, 'YYYY-MM-DD h:mma') : moment(to, 'YYYY-MM-DD')
        this.game.endTime = format.unix()
      },
      endTime (to, from) {
        let format = this.endDate ? moment(to + ' ' + this.endDate, 'h:mma YYYY-MM-DD') : moment(to, 'h:mma')
        this.game.endTime = format.unix()
      }
    },
    data () {
      return {
        dialog: {
          changesSaved: false
        },
        loading: true,
        saving: false,
        db: this.$database.ref(`games/${this.$route.params.id}`),
        game: {},
        startDate: null,
        startTime: null,
        endDate: null,
        endTime: null,
        picker: {}
      }
    },
    computed: {
      gameType () {
        let type = this.$store.state.gameTypes.find(g => (g.value === this.game.type))
        return type ? type.text : 'Loading...'
      },
      date: {
        get () { return this.game.time ? this.$timestamp(this.game.time, 'YYYY-MM-DD') : null },
        set (value) {
          let format = this.time ? moment(value + ' ' + this.time, 'YYYY-MM-DD h:mma') : moment(value, 'YYYY-MM-DD')
          this.game.time = format.unix()
        }
      },
      time: {
        get () { return this.game.time ? this.$timestamp(this.game.time, 'h:mma') : null },
        set (value) {
          let format = this.date ? moment(value + ' ' + this.date, 'h:mma YYYY-MM-DD') : moment(value, 'h:mma')
          this.game.time = format.unix()
        }
      }
    },
    methods: {
      saveChanges () {
        this.saving = true
        if (this.$refs.gameForm.validate()) {
          this.db.set(this.game).then(() => {
            this.dialog.changesSaved = true
            this.saving = false
          })
        }
      }
    },
    created () {
      this.db.once('value').then(snapshot => {
        let game = snapshot.val()

        if (game.startTime) {
          let time = moment.unix(game.startTime)
          this.startDate = time.format('YYYY-MM-DD')
          this.startTime = time.format('h:mma')
        }

        if (game.endTime) {
          let time = moment.unix(game.endTime)
          this.endDate = time.format('YYYY-MM-DD')
          this.endTime = time.format('h:mma')
        }

        this.loading = false
        this.game = game
      })
    }
  }
</script>

<style scoped>
  .menu {
    width: 48.57%;
  }
</style>
